
%define Werror_cflags %nil

%define _disable_ld_no_undefined 1

%define opengl_ver 4.5

%define makedepend		%{_bindir}/gccmakedep

%define d3dname			d3d
%define eglname			mesaegl
%define glname			mesagl
%define glwname			mesaglw
%define glesv1name		mesaglesv1
%define glesv2name		mesaglesv2
%define openvgname		mesaopenvg
%define glapiname		glapi
%define gbmname			gbm
%define waylandeglname	wayland-egl
%define xaname			xatracker

%define d3dmajor		1
%define eglmajor		1
%define glmajor			1
%define glwmajor		1
%define glesv1major		1
%define glesv2major		2
%define openvgmajor		1
%define glapimajor		0
%define gbmmajor		1
%define waylandeglmajor	1
%define osmesamajor		8
%define xamajor			2

%define libd3dname			%mklibname %{d3dname} %{d3dmajor}
%define libeglname          %mklibname %{eglname} %{eglmajor}
%define libglname			%mklibname %{glname} %{glmajor}
%define libglwname			%mklibname %{glwname} %{glwmajor}
%define libglesv1name		%mklibname %{glesv1name}_ %{glesv1major}
%define libglesv2name		%mklibname %{glesv2name}_ %{glesv2major}
%define libopenvgname		%mklibname %{openvgname} %{openvgmajor}
%define libglapiname		%mklibname %{glapiname} %{glapimajor}
%define libgbmname			%mklibname %{gbmname} %{gbmmajor}
%define libwaylandeglname	%mklibname %{waylandeglname} %{waylandeglmajor}
%define libosmesaname		%mklibname osmesa %{osmesamajor}
%define libxaname			%mklibname %{xaname} %{xamajor}

%define dridrivers			%mklibname dri-drivers

%define osmesadevel			%mklibname osmesa -d

# Architecture-independent Virtual provides:
%define libd3dname_virt			lib%{d3dname}
%define libeglname_virt			lib%{eglname}
%define libglname_virt			lib%{glname}
%define libglwname_virt			lib%{glwname}
%define libglesv1name_virt		lib%{glesv1name}
%define libglesv2name_virt		lib%{glesv2name}
%define libopenvgname_virt	l	ib%{openvgname}
%define libglapiname_virt       lib%{glapiname}
%define libgbmname_virt       	lib%{gbmname}
%define libwaylandeglname_virt	lib%{waylandeglname}
%define libxaname_virt			lib%{xaname}

%define oldlibglname	%mklibname MesaGL 1

%define mesasrcdir		%{_prefix}/src/Mesa/
%define driver_dir		%{_libdir}/dri


Name:		mesa
Version: 	18.2.2
Release: 	%mkrel 1
Summary:	OpenGL %{opengl_ver} compatible 3D graphics library
Group:		System/Libraries
URL:		http://www.mesa3d.org
Source0:	mesa-%{version}.tar.xz
Patch0:		mesa-18.2.0-vulkan.patch
License:	MIT
Provides:	Mesa = %{version}-%release
Provides:	mesa-libGLU
Obsoletes:	Mesa < %{version}

Obsoletes:	%{_lib}dricore1 
Obsoletes:	%{_lib}dricore1-devel
Obsoletes:	%{_lib}llvmradeon9.2.0

BuildRequires: %{_lib}nettle-devel
BuildRequires: %{_lib}omxil-bellagio-devel
BuildRequires: %{_lib}talloc-devel
BuildRequires: %{_lib}drm-devel
BuildRequires: %{_lib}elfutils-devel
BuildRequires: %{_lib}expat1-devel
BuildRequires: %{_lib}udev0-devel
BuildRequires: %{_lib}vdpau-devel
BuildRequires: %{_lib}wayland-devel
BuildRequires: %{_lib}x11-devel
BuildRequires: %{_lib}xdamage-devel
BuildRequires: %{_lib}xext-devel
BuildRequires: %{_lib}xfixes-devel
BuildRequires: %{_lib}xxf86vm-devel
BuildRequires: %{_lib}va-devel
BuildRequires: libxcb-devel
BuildRequires: llvm-devel
BuildRequires: gccmakedep
BuildRequires: x11-proto-devel
BuildRequires: libxml2-python
BuildRequires: makedepend
BuildRequires: bison
BuildRequires: flex
BuildRequires: python-mako
BuildRequires: %{_lib}wayland-devel
BuildRequires: wayland-protocols-devel
BuildRequires: lm_sensors-devel

Obsoletes: %{_lib}dri-drivers < %version
Obsoletes: %{_lib}gbm1 < %version
Obsoletes: %{_lib}glapi0 < %version
Obsoletes: %{_lib}mesaegl1  < %version
Obsoletes: %{_lib}mesagl1 < %version 
Obsoletes: %{_lib}mesaglesv1_1  < %version
Obsoletes: %{_lib}mesaglesv2_2  < %version
Obsoletes: %{_lib}mesaopenvg1  < %version
Obsoletes: %{_lib}osmesa8 < %version
Obsoletes: %{_lib}vdpau-driver < %version 
Obsoletes: %{_lib}wayland-egl1 < %version 
Obsoletes: %{_lib}xatracker2  < %version
Obsoletes: mesa < %version
Obsoletes: mesagl < %{version}


Provides: %{_lib}dri-drivers = %version-%release
Provides: %{_lib}gbm1 = %version-%release
Provides: %{_lib}glapi0 = %version-%release
Provides: %{_lib}mesaegl1 = %version-%release
Provides: %{_lib}mesagl1 = %version-%release
Provides: %{_lib}mesaglesv1_1 = %version-%release 
Provides: %{_lib}mesaglesv2_2  = %version-%release
Provides: %{_lib}mesaopenvg1 = %version-%release 
Provides: %{_lib}osmesa8  = %version-%release
Provides: %{_lib}vdpau-driver = %version-%release 
Provides: %{_lib}wayland-egl1  = %version-%release
Provides: %{_lib}xatracker2  = %version-%release
Provides: mesa = %version-%release
Provides: mesagl = %version-%release
Provides: libmesagl = %version-%release

%description
OpenGL compatible 3D graphics library


%package	devel
Summary:	Development files for Mesa
Group:		Development/Libraries
Provides:	Mesa-common-devel = %{version}-%{release}
Obsoletes:	Mesa-common-devel < %{version}

Obsoletes: mesagl-devel < %{version}
Obsoletes: mesa-common-devel < %{version}
Obsoletes: %{_lib}gbm1-devel < %{version}
Obsoletes: %{_lib}glapi0-devel < %{version}
Obsoletes: %{_lib}mesaegl1-devel < %{version}
Obsoletes: %{_lib}mesagl1-devel < %{version}
Obsoletes: %{_lib}mesaglesv1_1-devel < %{version}
Obsoletes: %{_lib}mesaglesv2_2-devel < %{version}
Obsoletes: %{_lib}mesaopenvg1-devel < %{version}
Obsoletes: %{_lib}osmesa-devel < %{version}
Obsoletes: %{_lib}wayland-egl1-devel < %{version}
Obsoletes: %{_lib}xatracker2-devel  < %{version}

Provides: mesagl-devel = %{version}-%{release}
Provides: mesa-common-devel = %{version}-%{release}
Provides: %{_lib}gbm1-devel = %{version}-%{release}
Provides: %{_lib}glapi0-devel = %{version}-%{release}
Provides: %{_lib}mesaegl1-devel = %{version}-%{release}
Provides: %{_lib}mesagl1-devel = %{version}-%{release}
Provides: %{_lib}mesaglesv1_1-devel = %{version}-%{release}
Provides: %{_lib}mesaglesv2_2-devel = %{version}-%{release}
Provides: %{_lib}mesaopenvg1-devel = %{version}-%{release}
Provides: %{_lib}osmesa-devel = %{version}-%{release}
Provides: %{_lib}wayland-egl1-devel = %{version}-%{release}
Provides: %{_lib}xatracker2-devel = %{version}-%{release} 
Provides: libmesagl-devel = %{version}-%{release}
Provides: GL-devel = %{version}-%{release}
#------------------------------------------------------------------------------

%description devel
Development files for Mesa


%prep
%setup -q
%apply_patches

autoconf

%build

export LDFLAGS="-L%{_libdir}/llvm"

%configure2_5x \
		--disable-llvm-shared-libs \
		--enable-gallium-osmesa \
		--with-dri-driverdir=%{_libdir}/dri \
		--enable-egl \
		--enable-gles1 \
		--enable-gles2 \
		--disable-xvmc \
		--enable-vdpau \
		--enable-va \
		--with-platforms=x11,wayland,drm \
		--enable-shared-glapi \
		--enable-gbm \
		--enable-glx \
		--enable-glx-tls \
		--enable-llvm \
		--enable-dri \
		--enable-xa \
		--enable-nine \
		--enable-lmsensors \
		--with-gallium-drivers=r300,r600,radeonsi,nouveau,svga,swrast,virgl \
	    --with-dri-drivers=swrast,nouveau,radeon,r200,i915,i965 \
	    --with-vulkan-drivers=intel,radeon

%make

%install
rm -rf %buildroot
%makeinstall_std

mkdir -p $RPM_BUILD_ROOT%{_libdir}/mesa
pushd $RPM_BUILD_ROOT%{_libdir}/mesa
for l in ../libGL.so.*; do cp -a $l .; done
popd

# libvdpau opens the versioned name, don't bother including the unversioned
rm -f %{buildroot}%{_libdir}/vdpau/*.so

# strip out useless headers
rm -f %{buildroot}%{_includedir}/GL/w*.h

# remove .la files
find %{buildroot} -name '*.la' -delete

mkdir -p %buildroot/usr/lib/xorg/modules
ln -sf /usr/lib/dri %{buildroot}/usr/lib/xorg/modules/dri

%files
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/drirc

%dir %{_libdir}/dri
%{_libdir}/dri/*_dri.so
%{_libdir}/xorg/modules/dri

%{_libdir}/libGL.so.*
%dir %{_libdir}/mesa
%{_libdir}/mesa/libGL.so.%{glmajor}*

%{_libdir}/libEGL.so.%{eglmajor}*

%{_libdir}/libglapi.so.%{glapimajor}*
%{_libdir}/libGLESv1_CM.so.%{glesv1major}*
%{_libdir}/libGLESv2.so.%{glesv2major}*

%{_libdir}/libgbm.so.%{gbmmajor}
%{_libdir}/libgbm.so.%{gbmmajor}.*
#%{_libdir}/libwayland-egl.so.%{waylandeglmajor}
#%{_libdir}/libwayland-egl.so.%{waylandeglmajor}.*

%{_libdir}/vdpau/libvdpau_nouveau.so.*
%{_libdir}/vdpau/libvdpau_r600.so.*
%{_libdir}/vdpau/libvdpau_radeonsi.so.*
%{_libdir}/vdpau/libvdpau_r300.so.*
%{_libdir}/libxatracker.so.%{xamajor}*
%{_libdir}/d3d/*.so.*

%{_libdir}/dri/nouveau_drv_video.so
%{_libdir}/dri/r600_drv_video.so
%{_libdir}/dri/radeonsi_drv_video.so

%dir %{_datadir}/vulkan
%dir %{_datadir}/vulkan/icd.d
%{_datadir}/vulkan/icd.d/intel_icd*.json
%{_libdir}/libvulkan_intel.so

%{_datadir}/vulkan/icd.d/radeon_icd.i586.json
%{_libdir}/libvulkan_radeon.so

%{_libdir}/libOSMesa.so.%{osmesamajor}
%{_libdir}/libOSMesa.so.%{osmesamajor}.*
#---------------------------------------------------

%files devel
%defattr(-,root,root)
%dir %{_includedir}/GL
%{_includedir}/GL/gl.h
%{_includedir}/GL/glcorearb.h
%{_includedir}/GL/glext.h
%{_includedir}/GL/gl_mangle.h
%{_includedir}/GL/glx.h
%{_includedir}/GL/glxext.h
%{_includedir}/GL/glx_mangle.h
%{_libdir}/libGL.so
%{_libdir}/pkgconfig/gl.pc
%{_libdir}/pkgconfig/dri.pc


%dir %{_includedir}/GL/internal
%{_includedir}/GL/internal/dri_interface.h

%{_includedir}/EGL
%{_includedir}/KHR
%{_libdir}/libEGL.so
%{_libdir}/pkgconfig/egl.pc

%dir %{_includedir}/GL
%{_includedir}/GL/osmesa.h
%{_libdir}/libOSMesa.so
%{_libdir}/pkgconfig/osmesa.pc

%{_libdir}/libglapi.so

%{_includedir}/GLES
%{_libdir}/libGLESv1_CM.so
%{_libdir}/pkgconfig/glesv1_cm.pc

%{_includedir}/GLES2
%{_includedir}/GLES3
%{_libdir}/libGLESv2.so
%{_libdir}/pkgconfig/glesv2.pc

%{_includedir}/gbm.h
%{_libdir}/libgbm.so
%{_libdir}/pkgconfig/gbm.pc

#%{_libdir}/libwayland-egl.so
#%{_libdir}/pkgconfig/wayland-egl.pc

%{_libdir}/libxatracker.so
%{_includedir}/xa_tracker.h
%{_includedir}/xa_composite.h
%{_includedir}/xa_context.h
%{_libdir}/pkgconfig/xatracker.pc
%{_includedir}/d3dadapter
%{_libdir}/d3d/*.so
%{_libdir}/pkgconfig/d3d.pc
%{_includedir}/vulkan/

%changelog
* Mon Oct 15 2018 adrianomorselli <adrianomorselli> 18.2.2-1uplos2018
- update
